Index: doc/CODING-GUIDELINES
===================================================================
RCS file: /usr/cvsroot/asterisk/doc/CODING-GUIDELINES,v
retrieving revision 1.4
diff -u -r1.4 CODING-GUIDELINES
--- doc/CODING-GUIDELINES	8 Nov 2004 02:49:33 -0000	1.4
+++ doc/CODING-GUIDELINES	18 Jan 2005 17:54:53 -0000
@@ -76,3 +76,50 @@
 			baz();
 	}
 }
+
+
+
+Always initilize *every* variable to something.
+ char *options = NULL;
+
+Always name variables something that will make sense to aliens who find your code in 100 years.
+ Avoid: char *p, struct ast_channel *c
+
+Make some indication in the name of variables so you know they are global
+ static char global_something[80]
+
+When making applications, always ast_strdupa(data) to a local pointer.
+ if(data)
+  mydata = ast_strdupa(data);
+
+Always derefrence or localize pointers to things that are not yours like chan members 
+ channame = ast_strdupa(chan->name);
+
+If you do the same or a similar operation more than 1 time, make it a function or macro.
+
+Make sure you are not duplicating any functionality already found in an API call somewhere.
+
+When you achieve your desired functionalty, make another few refactor passes over the code to optimize it.
+
+If you are asked to make changes to your patch, there is a good chance the changes will introduce bugs, check it even more at this stage.
+
+Avoid needless malloc(),strdup()  calls.  If you only need the value in the scope of your function 
+try ast_strdupa() or declare struts static and pass them as a pointer with &.
+
+If you are going to reuse a computable value, save it in a variable instead of recomputing it over and over.
+
+Just an Example:
+
+ if (strlen(name)) {
+  newname = alloca(strlen(name));
+  strncpy(newname, name, strlen(name);
+ }
+  
+vs
+
+ if((len = strlen(name))) {
+  newname = alloca(len);
+  strncpy(newname, name, len);
+ }
+
+
